#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # PIG et Paramètres (Cloudera) (correction)
# 
# Correction.

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Connexion au cluster
# 
# On prend le cluster [Cloudera](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/notebooks/td3a_cenonce_session6.html#p2). Il faut exécuter ce script pour pouvoir notifier au notebook que la variable ``params`` existe.

# In[2]:


import pyensae
from pyquickhelper.ipythonhelper import open_html_form
params={"server":"df...fr", "username":"", "password":""}
open_html_form(params=params,title="server + credentials", key_save="params")


# In[3]:


import pyensae
get_ipython().run_line_magic('load_ext', 'pyensae')
get_ipython().run_line_magic('load_ext', 'pyenbc')
password = params["password"]
server = params["server"]
username = params["username"]
client = get_ipython().run_line_magic('remote_open', '')
client


# ## Exercice 1 : min, max
# 
# On ajoute deux paramètres pour construire l'histogramme entre deux valeurs ``a``,``b``. Ajouter ces deux paramètres au nom du fichier de sortie peut paraître raisonnable mais l'interpréteur a du mal à identifier les paramètres ``Undefined parameter : bins_``. On utilise des tirets.

# In[4]:


get_ipython().run_cell_magic('PIG', 'histogramab.pig', "\nvalues = LOAD 'random/random.sample.txt' USING PigStorage('\\t') AS (x:double);\n\nvalues_f = FILTER values BY x >= $a AND x <= $b ;   -- ligne ajoutée\n\nvalues_h = FOREACH values_f GENERATE x, ((int)(x / $bins)) * $bins AS h ;\n\nhist_group = GROUP values_h BY h ;\n\nhist = FOREACH hist_group GENERATE group, COUNT(values_h) AS nb ;\n\nSTORE hist INTO 'random/histo_$bins-$a-$b.txt' USING PigStorage('\\t') ;\n")


# In[5]:


if client.dfs_exists("random/histo_0.1-0.2-0.8.txt"):
    client.dfs_rm("random/histo_0.1-0.2-0.8.txt", recursive=True)


# In[6]:


client.pig_submit("histogramab.pig", redirection="redirection", 
                  params =dict(bins="0.1", a="0.2", b="0.8") )


# In[7]:


get_ipython().run_line_magic('remote_cmd', 'tail redirection.err')


# In[8]:


get_ipython().run_line_magic('dfs_ls', 'random')


# In[9]:


if os.path.exists("histo.txt") : os.remove("histo.txt")
client.download_cluster("random/histo_0.1-0.2-0.8.txt","histo.txt", merge=True)


# In[10]:


import matplotlib.pyplot as plt
plt.style.use('ggplot')
import pandas
df = pandas.read_csv("histo.txt", sep="\t",names=["bin","nb"])
df.plot(x="bin",y="nb",kind="bar")


# In[11]: